#!/bin/sh

cnt=$1
ops=$2

if [ -z "$cnt" ]
then
	cnt=10
fi

if [ -z "$ops" ]
then
	ops=4
fi

rm -rf test
mkdir test
cd test
bzr init .
echo "a" > a
echo "b" > b
echo "c" > c
echo "d" > d
bzr add a b c d > /dev/null 2>&1
bzr commit -m"init" > /dev/null 2>&1

rand(){
	time=`date +'%N'`
	time=`expr $time % $1`
	echo $time
}

scramble () {
	ret=""
	list="a b c d e f g h i j k l m n o p q r s t u v"
	while [ "$list" ]
	do
		s=`echo $list | wc -w`
		r=`rand $s`
		r=`expr $r + 1`
		c=`echo $list | cut -d' ' -f $r`
		ret="$ret $c"
		newlist=""
		for i in `seq $s`
		do
			if [ $i != $r ]
			then
				c=`echo $list | cut -d' ' -f $i`
				newlist="$newlist $c"
			fi
		done
		list=$newlist
	done
	echo "$ret"
}

add() {
	for i in `scramble`
	do
		if [ ! -f $i ]
		then
			echo $i > $i
			echo "bzr add $i"
			bzr add $i > /dev/null 2>&1
			return
		fi
	done
}

del() {
	for i in `scramble`
	do
		if [ -f $i ]
		then
			echo "bzr rm $i"
			bzr rm --force $i > /dev/null 2>&1
			return
		fi
	done
}

ren() {
	of=""
	nf=""
	old=`scramble`
	new=`scramble`
	for i in $old
	do
		if [ -f $i ]
		then
			of=$i
			break
		fi
	done
	for i in $new
	do
		if [ ! -f $i ]
		then
			nf=$i
			break
		fi
	done

	if [ "$of" -a "$nf" ]
	then
		echo "bzr mv $of $nf"
		bzr mv $of $nf > /dev/null 2>&1
	fi
}

run_op() {
	case `rand 3` in
	0) add ;;
	1) del ;;
	2) ren ;;
	esac
}

for n in `seq $cnt`
do
	for j in `seq $ops`	
	do
		run_op
	done
	echo "bzr commit $n"
	bzr commit -q -m"loop $n" > /dev/null 2>&1
done

bzr-fast-export.py .
